/**
 * Copyright bradsedito ( http://wonderfl.net/user/bradsedito )
 * MIT License ( http://www.opensource.org/licenses/mit-license.php )
 * Downloaded from: http://wonderfl.net/c/wfTz
 */

// forked from ile's WaterDropMaker
/* 
shape で WaterDrop を作ってみました。 
*/
package  {
    
import flash.display.Sprite;
    public class Suiteki extends Sprite {
        private var test:WaterDropMaker;
        
        public function Suiteki() {
            //Specify the same color as the backgroundColor;
            
            graphics.beginFill(0x131413);
            graphics.drawRect(0, 0, stage.stageWidth, stage.stageHeight);
            graphics.endFill();
            
            test = new WaterDropMaker(50, 0xBBBBFF);
            addChild(test);
            test.x = 100;
            test.y = 100;
            test.rotation = -45;
        }
    }
}

import flash.display.Sprite;
import flash.display.Shape;
import flash.display.GradientType;
import flash.display.SpreadMethod;
import flash.display.Graphics;
import flash.geom.Matrix;

class WaterDropMaker extends Sprite {

    public function WaterDropMaker(n:uint,c:uint):void {
        var dropSize:uint = n;
        var baseColor:uint = c;
        var shadowColor:uint = 0x000000;
        var lightColor:uint = 0xFFFFFF;
        
        var container:Sprite = addChild(new Sprite) as Sprite;
        //container.x = container.y = dropSize;
     
        var shape:Shape = container.addChild(new Shape) as Shape;
        var g:Graphics = shape.graphics;
        var matrix:Matrix = new Matrix;
        
        this.alpha = .2;
        
        //long shadow
        shape =  container.addChild(new Shape) as Shape;
        g = shape.graphics;
        //createGradientBox(w,h,r,X,Y)
        matrix.createGradientBox(dropSize * 2, dropSize * 4, 0, -dropSize, -dropSize*2);
        g.beginGradientFill(GradientType.RADIAL, [shadowColor, shadowColor, shadowColor], [0.05,0.03,0], [0,200,255], matrix, SpreadMethod.PAD);
        g.moveTo(-dropSize, 0);
        g.curveTo ( -dropSize , dropSize * 2, 0 , dropSize * 2 );
        g.curveTo ( dropSize , dropSize*2, dropSize , 0 );
        g.endFill();
        
        //around OUTSIDE shadow
        shape =  container.addChild(new Shape) as Shape;
        g = shape.graphics;
        matrix.createGradientBox(dropSize * 2.6, dropSize * 2.6+dropSize/5, 0, -dropSize*1.3, -dropSize*1.3);
        g.beginGradientFill(GradientType.RADIAL, [shadowColor,shadowColor, shadowColor], [0.07,0.05,0], [0,200,255], matrix, SpreadMethod.PAD);
        g.drawCircle(0, dropSize/5, dropSize*1.5);
        g.endFill();
    
        //base color
        shape =  container.addChild(new Shape) as Shape;
        g = shape.graphics;
        g.beginFill (baseColor, 1.0);
        g.drawCircle  ( 0, 0 , dropSize);
        g.endFill();
        
        //around INSIDE shadow
        shape =  container.addChild(new Shape) as Shape;
        g = shape.graphics;
        matrix.createGradientBox(dropSize * 3.5, dropSize * 3.7, 0, -dropSize * 1.8, -dropSize * 1.0);
        g.beginGradientFill(GradientType.RADIAL, [shadowColor,shadowColor, shadowColor], [0,0.05,0.07], [0,200,255], matrix, SpreadMethod.PAD);
        g.drawCircle  ( 0, 0 , dropSize);
        g.endFill();
        
        //base gradation
        shape =  container.addChild(new Shape) as Shape;
        g = shape.graphics;
        matrix.createGradientBox(dropSize * 3.5, dropSize * 3.7, 0, -dropSize*1.8, -dropSize*1.0);
        g.beginGradientFill(GradientType.RADIAL, [lightColor,lightColor, lightColor,lightColor,lightColor,lightColor], [0.8,0.5, 0.2,0.1,0,0.5], [0,70, 181,216,245,255], matrix, SpreadMethod.PAD);
        g.drawCircle(0, 0, dropSize);
        g.endFill();
        
        //under　shadow
        shape =  container.addChild(new Shape) as Shape;
        g = shape.graphics;
        matrix.createGradientBox(dropSize * 5, dropSize * 5, 0, -dropSize*2.5, -dropSize*3);
        g.beginGradientFill(GradientType.RADIAL, [baseColor,baseColor,baseColor,baseColor], [0,0, 1,1], [0,95,222,255], matrix, SpreadMethod.PAD);
        g.drawEllipse  ( -dropSize , -dropSize/1.5 , dropSize*2 , dropSize/0.6);
        g.endFill();
        
        //highlight
        shape =  container.addChild(new Shape) as Shape;
        g = shape.graphics;
        matrix.createGradientBox(dropSize/2, dropSize/2, 0, -dropSize/4, -dropSize*0.9);
        g.beginGradientFill(GradientType.RADIAL, [lightColor,lightColor,lightColor], [1,0.5 ,0], [0,50,255], matrix, SpreadMethod.PAD);
        g.drawCircle(0, 0, dropSize);
        g.endFill();
        
    }
}